

/**
 * Copyright (C) 2006-2008 Sun Microsystems, Inc.
 * 
 * Sun Microsystems, Inc. confidential
 * All rights reserved
 *
 * This file is autogenerated by glue-jaxws.xsl, DO NOT EDIT! 
 */

package com.sun.xml.ws.commons.virtualbox;

import java.math.BigInteger;
import java.util.List;
import java.util.UUID;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceException;
import com.sun.xml.ws.commons.virtualbox.IUnknown;

import org.virtualbox.service.InvalidObjectFaultMsg;
import org.virtualbox.service.RuntimeFaultMsg;
import org.virtualbox.service.VboxService;
import org.virtualbox.service.VboxPortType;

public class ISystemProperties extends IUnknown {

    public static ISystemProperties cast(IUnknown other) {
        return new ISystemProperties(other.getRef(), other.getRemoteWSPort());
    }

    public ISystemProperties(String _this, VboxPortType port) {
        super(_this,port);
    }

    // read-only attribute ISystemProperties::minGuestRAM of type unsigned long
    public Long getMinGuestRAM() {
        try {
            Long retVal = port.iSystemPropertiesGetMinGuestRAM(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::maxGuestRAM of type unsigned long
    public Long getMaxGuestRAM() {
        try {
            Long retVal = port.iSystemPropertiesGetMaxGuestRAM(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::minGuestVRAM of type unsigned long
    public Long getMinGuestVRAM() {
        try {
            Long retVal = port.iSystemPropertiesGetMinGuestVRAM(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::maxGuestVRAM of type unsigned long
    public Long getMaxGuestVRAM() {
        try {
            Long retVal = port.iSystemPropertiesGetMaxGuestVRAM(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::maxVDISize of type unsigned long long
    public BigInteger getMaxVDISize() {
        try {
            BigInteger retVal = port.iSystemPropertiesGetMaxVDISize(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::networkAdapterCount of type unsigned long
    public Long getNetworkAdapterCount() {
        try {
            Long retVal = port.iSystemPropertiesGetNetworkAdapterCount(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::serialPortCount of type unsigned long
    public Long getSerialPortCount() {
        try {
            Long retVal = port.iSystemPropertiesGetSerialPortCount(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::parallelPortCount of type unsigned long
    public Long getParallelPortCount() {
        try {
            Long retVal = port.iSystemPropertiesGetParallelPortCount(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read-only attribute ISystemProperties::maxBootPosition of type unsigned long
    public Long getMaxBootPosition() {
        try {
            Long retVal = port.iSystemPropertiesGetMaxBootPosition(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::defaultVDIFolder of type wstring
    public String getDefaultVDIFolder() {
        try {
            String retVal = port.iSystemPropertiesGetDefaultVDIFolder(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setDefaultVDIFolder(String value) {
        try {
            port.iSystemPropertiesSetDefaultVDIFolder(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::defaultMachineFolder of type wstring
    public String getDefaultMachineFolder() {
        try {
            String retVal = port.iSystemPropertiesGetDefaultMachineFolder(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setDefaultMachineFolder(String value) {
        try {
            port.iSystemPropertiesSetDefaultMachineFolder(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::remoteDisplayAuthLibrary of type wstring
    public String getRemoteDisplayAuthLibrary() {
        try {
            String retVal = port.iSystemPropertiesGetRemoteDisplayAuthLibrary(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setRemoteDisplayAuthLibrary(String value) {
        try {
            port.iSystemPropertiesSetRemoteDisplayAuthLibrary(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::webServiceAuthLibrary of type wstring
    public String getWebServiceAuthLibrary() {
        try {
            String retVal = port.iSystemPropertiesGetWebServiceAuthLibrary(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setWebServiceAuthLibrary(String value) {
        try {
            port.iSystemPropertiesSetWebServiceAuthLibrary(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::HWVirtExEnabled of type boolean
    public Boolean getHWVirtExEnabled() {
        try {
            Boolean retVal = port.iSystemPropertiesGetHWVirtExEnabled(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setHWVirtExEnabled(Boolean value) {
        try {
            port.iSystemPropertiesSetHWVirtExEnabled(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute ISystemProperties::LogHistoryCount of type unsigned long
    public Long getLogHistoryCount() {
        try {
            Long retVal = port.iSystemPropertiesGetLogHistoryCount(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setLogHistoryCount(Long value) {
        try {
            port.iSystemPropertiesSetLogHistoryCount(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
}
