

/**
 * Copyright (C) 2006-2008 Sun Microsystems, Inc.
 * 
 * Sun Microsystems, Inc. confidential
 * All rights reserved
 *
 * This file is autogenerated by glue-jaxws.xsl, DO NOT EDIT! 
 */

package com.sun.xml.ws.commons.virtualbox;

import java.math.BigInteger;
import java.util.List;
import java.util.UUID;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceException;
import com.sun.xml.ws.commons.virtualbox.IUnknown;

import org.virtualbox.service.InvalidObjectFaultMsg;
import org.virtualbox.service.RuntimeFaultMsg;
import org.virtualbox.service.VboxService;
import org.virtualbox.service.VboxPortType;

public class IVRDPServer extends IUnknown {

    public static IVRDPServer cast(IUnknown other) {
        return new IVRDPServer(other.getRef(), other.getRemoteWSPort());
    }

    public IVRDPServer(String _this, VboxPortType port) {
        super(_this,port);
    }

    // read/write attribute IVRDPServer::enabled of type boolean
    public Boolean getEnabled() {
        try {
            Boolean retVal = port.ivrdpServerGetEnabled(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setEnabled(Boolean value) {
        try {
            port.ivrdpServerSetEnabled(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::port of type unsigned long
    public Long getPort() {
        try {
            Long retVal = port.ivrdpServerGetPort(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setPort(Long value) {
        try {
            port.ivrdpServerSetPort(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::netAddress of type wstring
    public String getNetAddress() {
        try {
            String retVal = port.ivrdpServerGetNetAddress(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setNetAddress(String value) {
        try {
            port.ivrdpServerSetNetAddress(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::authType of type VRDPAuthType
    public org.virtualbox.VRDPAuthType getAuthType() {
        try {
            org.virtualbox.VRDPAuthType retVal = port.ivrdpServerGetAuthType(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setAuthType(org.virtualbox.VRDPAuthType value) {
        try {
            port.ivrdpServerSetAuthType(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::authTimeout of type unsigned long
    public Long getAuthTimeout() {
        try {
            Long retVal = port.ivrdpServerGetAuthTimeout(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setAuthTimeout(Long value) {
        try {
            port.ivrdpServerSetAuthTimeout(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::allowMultiConnection of type boolean
    public Boolean getAllowMultiConnection() {
        try {
            Boolean retVal = port.ivrdpServerGetAllowMultiConnection(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setAllowMultiConnection(Boolean value) {
        try {
            port.ivrdpServerSetAllowMultiConnection(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }

    // read/write attribute IVRDPServer::reuseSingleConnection of type boolean
    public Boolean getReuseSingleConnection() {
        try {
            Boolean retVal = port.ivrdpServerGetReuseSingleConnection(_this);
            return retVal;
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
    public void setReuseSingleConnection(Boolean value) {
        try {
            port.ivrdpServerSetReuseSingleConnection(_this, value);
        } catch (InvalidObjectFaultMsg e) {
            throw new WebServiceException(e);
        } catch (RuntimeFaultMsg e) {
            throw new WebServiceException(e);
        }
    }
}
